#if !defined(AFX_FTS_MFXPROPPAGE_H__00EDAF21_0203_11D2_AFFF_00A0C90DA071__INCLUDED_)
#define AFX_FTS_MFXPROPPAGE_H__00EDAF21_0203_11D2_AFFF_00A0C90DA071__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CFTS_MFXPropPage dialog

class CFTS_MFXPropPage : public CDialog,
									public IPropertyPage
{
// Construction
public:
	CFTS_MFXPropPage(CWnd* pParent = NULL);   // standard constructor
	~CFTS_MFXPropPage();   // standard destructor

// Dialog Data
	//{{AFX_DATA(CFTS_MFXPropPage)
	enum { IDD = IDD_PROPPAGE };
	CSpinButtonCtrl	m_SpinChannelToRelay;
	CSpinButtonCtrl	m_SpinChannelToProcessUpTo;
	BOOL m_bypass_fts;
 BOOL m_fts_raw_data;
	BOOL m_fts_notes;
	BOOL m_fts_controllers;
	BOOL m_fts_pitch_bends;
	BOOL m_fts_aftertouch;
	BOOL m_fts_patches;
 BOOL m_fts_midi_in_data;
	BOOL	m_fts_send_on_if_not_processed;
	BOOL	m_fts_mute;
	BOOL	m_fts_log_to_text;
	BOOL	m_fts_mute_midi_in;
	BOOL	m_fts_skip_all_controllers;
	int		m_fts_channel_to_relay;
	BOOL	m_fts_choose_channel_to_relay;
	BOOL	m_fts_relay_to_same_chann;
	BOOL	m_fts_process_all_channels_up_to;
	int		m_fts_channel_to_process_up_to;
	BOOL	m_fts_verbose_log;
	int		m_fts_pitch_bend_delay;
	BOOL	m_fts_do_pitch_bend_delay;
	BOOL	m_do_resets;
	BOOL	m_do_resets_again;
	//}}AFX_DATA

	// *** IPropertyPage methods ***
	STDMETHODIMP_(HRESULT)	SetPageSite(LPPROPERTYPAGESITE pPageSite);
	STDMETHODIMP_(HRESULT)	Activate(HWND hwndParent, LPCRECT prect, BOOL fModal);
	STDMETHODIMP_(HRESULT)	Deactivate(void);
	STDMETHODIMP_(HRESULT)	GetPageInfo(LPPROPPAGEINFO pPageInfo);
	STDMETHODIMP_(HRESULT)	SetObjects(ULONG cObjects, LPUNKNOWN *ppUnk);
	STDMETHODIMP_(HRESULT)	Show(UINT nCmdShow);
	STDMETHODIMP_(HRESULT)	Move(LPCRECT prect);
	STDMETHODIMP_(HRESULT)	IsPageDirty(void);
	STDMETHODIMP_(HRESULT)	Apply(void);
	STDMETHODIMP_(HRESULT)	Help(LPCWSTR lpszHelpDir);
	STDMETHODIMP_(HRESULT)	TranslateAccelerator(LPMSG lpMsg);

	// *** IPlugInPropPageMFC methods ***
	// Implemented in FTS_MFXGen.cpp
	STDMETHODIMP_(BOOL)	CreateMFCDialog( HWND hwndParent );
	STDMETHODIMP_(BOOL)	DestroyMFCDialog();

	// *** IUnknown methods ***
	// Implemented in FTS_MFXGen.cpp
  	STDMETHODIMP_(HRESULT)	QueryInterface( REFIID riid, void** ppv );
  	STDMETHODIMP_(ULONG)		AddRef( void );
	STDMETHODIMP_(ULONG)		Release( void );


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFTS_MFXPropPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
// Implementation
private:
	LONG						m_cRef;
	CFTS_MFX*		m_pFilter;
	IPropertyPageSite*	m_pPageSite;
	BOOL						m_bDirty;

	static BOOL CALLBACK DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	// Generated message map functions
	//{{AFX_MSG(CFTS_MFXPropPage)
	afx_msg void OnCheckBypass();
	afx_msg void OnCheckRawData();
	afx_msg void OnCheckNoteOns();
	afx_msg void OnCheckControllers();
	afx_msg void OnCheckPitchBends();
	afx_msg void OnCheckAftertouch();
	afx_msg void OnCheckPatches();
	afx_msg void OnCheckMidiInData();
	afx_msg void OnCheckSendOnIfNotProcessed();
	afx_msg void OnCheckMute();
	afx_msg void OnCheckLogToText();
	afx_msg void OnRadioProcess();
	afx_msg void OnCheckMuteMidiIn();
	afx_msg void OnShowLog();
	afx_msg void OnCheckSkipAllFTSControllers();
	afx_msg void OnChangeEditChannelToRelay();
	afx_msg void OnCheckProcessAllChannelsUpToChann();
	afx_msg void OnCheckChooseChannelToRelay();
	afx_msg void OnCheckRelayToSameChann();
	afx_msg void OnChangeChannelToProcessUpTo();
	afx_msg void OnChangeEditChannelToProcessUpTo();
	afx_msg void OnCheckVerboseLog();
	afx_msg void OnButtonShowHelp();
	afx_msg void OnCheckDoResets();
	afx_msg void OnChangeEditPitchBendDelay();
	afx_msg void OnCheckDoPitchBendDelay();
	afx_msg void OnDeltaposSpinChannelToRelay(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposVscrollPitchBendDelay(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCheckDoResetsAgain();
	afx_msg void OnButtonTestPitchBendRange();
	afx_msg void OnButtonAllSoundOff();
	afx_msg void OnCheckProcessAllChannelsRetuneToAnyChannel();
	afx_msg void OnOnCheckRelayToSameChann();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FTS_MFXPROPPAGE_H__00EDAF21_0203_11D2_AFFF_00A0C90DA071__INCLUDED_)
