#include "stdafx.h"
#include <MidiFilter.h>
#include "FTS_MFX.h"
#include "FTS_MFXPropPage.h"
#include "externs.h"
#include <process.h>

HWND	hwndFTSMFX_is=0;
char started_mfx_relay;

char MakeAnyNewWindowsFolders(char *szFolder)
{
 //create extra folders if necessary
 int ipos=0;
 for(ipos=0;szFolder[ipos];ipos++)
  if(szFolder[ipos-1]!=':')
  if(szFolder[ipos]=='\\')
  {
   szFolder[ipos]='\0';
   CreateDirectory(szFolder,NULL);
   szFolder[ipos]='\\';
  }
 return 1;
}

BOOL FileExists(char *szPFile)
{
 WIN32_FIND_DATA wfd;\
 HANDLE hFile=FindFirstFile(szPFile,&wfd);\
 if(hFile!=INVALID_HANDLE_VALUE)\
 {\
  FindClose(hFile) ;\
  return 1;
 }
 return 0;
}

void GetModulePath(char *szModulePath,int iMax,char *szName)
{
 HMODULE hModule=GetModuleHandle("fts_mfx");
 int ifolder=0;
 GetModuleFileName(hModule,szModulePath,MAX_PATH);
 ifolder=find_char_from_end(szModulePath,'\\');
 if(ifolder>0)
  szModulePath[ifolder+1]='\0';
}

void FindDateAndtime(time_t *pltime,char tmpbuf[128])
{
 struct tm *today;
 time( pltime );
 today = localtime( pltime );
 strftime( tmpbuf, 128,"%#I %p %A, %B %d, %Y %Z",today);
}

void AddLogHeader(FILE *fplog)
{
 // MessageBox(0,"new log","debug",0);
 DECLARE_LOCAL(bypass_fts)
 DECLARE_LOCAL(fts_aftertouch)
 DECLARE_LOCAL(fts_controllers)
 DECLARE_LOCAL(fts_pitch_bends)
 DECLARE_LOCAL(fts_patches)
 DECLARE_LOCAL(fts_notes)
 DECLARE_LOCAL(fts_raw_data)
 DECLARE_LOCAL(fts_send_on_if_not_processed)
 DECLARE_LOCAL(fts_mute)
 DECLARE_LOCAL(fts_log_to_text)
 DECLARE_LOCAL(fts_mute_midi_in)
 DECLARE_LOCAL(fts_midi_in_data)
 DECLARE_LOCAL(fts_skip_all_controllers)
 DECLARE_LOCAL(fts_relay_to_same_chann)
 DECLARE_LOCAL(fts_choose_channel_to_relay)
 DECLARE_LOCAL_INT(fts_channel_to_relay)
 DECLARE_LOCAL(fts_verbose_log)
 DECLARE_LOCAL(fts_do_pitch_bend_delay)
 DECLARE_LOCAL_INT(fts_pitch_bend_delay)
 DECLARE_LOCAL(fts_process_all_channels_up_to)
 DECLARE_LOCAL_INT(fts_channel_to_process_up_to)
 DECLARE_LOCAL(do_resets)
 char tmpbuf[128];
 time_t ltime;
 FindDateAndtime(&ltime,tmpbuf);
#define LOG_VAL(val,sz) {if(val)fprintf(fplog,"%s ",sz);}
#define LOG_IVAL(ival,sz) {fprintf(fplog,"%s %d ",sz,ival);}
 LOG_VAL(fts_verbose_log,"Verbose Log, ")
 fprintf(fplog,"\n%s\n\nWhat to send via FTS:\n\n",tmpbuf);
 LOG_VAL(bypass_fts,"Bypass, ")
 LOG_VAL(fts_mute,"Mute, ")
 if(bypass_fts||fts_mute)
  fprintf(fplog,"\n(\n");
 LOG_VAL(fts_notes,"Notes ")
 LOG_VAL(fts_controllers,"Controllers ")
 LOG_VAL(fts_pitch_bends,"Pitch bends ")
 LOG_VAL(fts_aftertouch,"Aftertouch ")
 LOG_VAL(fts_raw_data,"Raw Data ")
 if(fts_send_on_if_not_processed)
  fprintf(fplog,"\n");
 LOG_VAL(fts_send_on_if_not_processed,"Send on if not processed, ")
 LOG_VAL(fts_skip_all_controllers,"Remove all controllers from the output stream (including added by FTS) ")
 LOG_VAL(fts_process_all_channels_up_to,"Relay all channels up to")
 if(fts_process_all_channels_up_to)
 LOG_IVAL(fts_channel_to_process_up_to," : ")
 LOG_VAL(fts_relay_to_same_chann,"No channel changes")
 LOG_VAL(fts_choose_channel_to_relay,"Choose channel to relay")
 if(fts_choose_channel_to_relay)
 LOG_IVAL(fts_channel_to_relay," : ")
 LOG_VAL(fts_do_pitch_bend_delay,"Pitch bend delay, ")
 if(fts_do_pitch_bend_delay)
 LOG_IVAL(fts_pitch_bend_delay," : ")
 if(bypass_fts||fts_mute)
  fprintf(fplog,"\n)\n");
 else
  fprintf(fplog,"\n");
 LOG_VAL(fts_midi_in_data,"Midi In Data, ")
 if(fts_midi_in_data)
  fprintf(fplog,"\n");
 log_header_up_to_date=1;
}

//file mapping: MFVC help (+ http://www.simpits.org/programming/datasharing/datasharing.html)
char szMapName[]="FractalTuneSmithyMFXEventsInOut";
HANDLE hEventsInOutMap;

void ConstructFileMapping(void)
{
 if(!hEventsInOutMap)
 {
  hEventsInOutMap=CreateFileMapping
  (INVALID_HANDLE_VALUE,NULL,PAGE_READWRITE,0
  ,sizeof(EVENTS_IN_OUT),szMapName
  );
  if(hEventsInOutMap!=NULL&&GetLastError()==ERROR_ALREADY_EXISTS) 
  { 
   CloseHandle(hEventsInOutMap); 
   hEventsInOutMap = NULL; 
  }
 }
}


void GetFileMapMem(EVENTS_IN_OUT **ppEventInOut)
{
 hEventsInOutMap=OpenFileMapping(FILE_MAP_ALL_ACCESS,FALSE,szMapName);
 if(hEventsInOutMap!=NULL)
 {
  PBYTE pMapAddress=(PBYTE)MapViewOfFile(hEventsInOutMap,FILE_MAP_ALL_ACCESS,0,0,0);
  if(pMapAddress!=NULL)
  {
   *ppEventInOut=(EVENTS_IN_OUT*)pMapAddress;
  } 
 }
} 

 
// destruction (client and server)
void FreeFileMapMem(EVENTS_IN_OUT *pEventInOut)
{
 if(hEventsInOutMap!=NULL)
 {
  if(pEventInOut)
  {
   UnmapViewOfFile(pEventInOut);
  }
  CloseHandle(hEventsInOutMap);
 }
 hEventsInOutMap=NULL;
}

int spawnl_2_args_in_quotes(int mode,const char *szPFile,const char *szarg,const char *szarg2)\
{\
	char szArgInQuotes[MAX_PATH+2];\
	char szPFileInQuotes[MAX_PATH+2];\
 if(szPFile[0]=='\0')
  return 0;
		sprintf(szPFileInQuotes,"\"%s\"",szPFile);\
		sprintf(szArgInQuotes,"\"%s\"",szarg);\
 if(szarg2)
  return _spawnl(mode,szPFile,szPFileInQuotes,szArgInQuotes,szarg2,NULL);\
 else
  return _spawnl(mode,szPFile,szPFileInQuotes,szArgInQuotes,NULL);\
}


char StartFTS(void)
{
 char szFTSPathFile[MAX_PATH];
 char szDllPath[MAX_PATH];
 static char found_time=0;
 time_t tnow=clock();
 static time_t twas;
 if(found_time)
 {
  if(tnow-twas<8*CLOCKS_PER_SEC)// 8 seconds
   return 0;
 }
 twas=tnow;
 found_time=1; 
 GetModulePath(szDllPath,MAX_PATH,"fts_mfx");
#ifdef _DEBUG
// strcpy(szDllPath,"C:\\ROB\\FTS\\debug\\");
#endif
 MakePathFile(szFTSPathFile,szDllPath,"Fractal Tune Smithy.exe");
 if(!FileExists(szFTSPathFile))
 {
  char szmsg[STRMAX+MAX_PATH];
  sprintf(szmsg,"Can't find FTS in the same folder as this plug in fts_mfx.dll, Sorry.\n\ncomplete path used:\n\n%s"
         ,szFTSPathFile
         );
  MessageBox(g_hDlgPropPage,szmsg,"Start up FTS",MB_ICONEXCLAMATION|MB_TOPMOST);
  return 0;
 }
	spawnl_2_args_in_quotes(_P_NOWAIT,szFTSPathFile,szFTSPathFile,"");
 return 1;
}

void InitVarsOnStartPlay(void);

HWND GetFTSWindow(void)
{
 HWND hwndFTSMFX;
 static char in_this;
 static time_t ltime_start;
 time_t ltime;
 if(in_this)
  return 0;
 in_this=1;
 if(hwndFTSMFX_is==NULL)
  started_mfx_relay=0;
 time(&ltime);
 hwndFTSMFX=hwndFTSMFX_is=FindWindow(SZ_FTS_MFX_HANDLER,NULL);
 // MessageBox(g_hDlgPropPage,"Find Window","Debug",0);
 if(!hwndFTSMFX)
 if(ltime-ltime_start>20)
 {
  int i=0;
  char started_mfx_relay=0,started_prog=0;
  #define szFractalTuneSmithy "FractalTuneSmithy"
  HWND	hwndFTS=FindWindow(szFractalTuneSmithy,NULL);
  if(!hwndFTS)
  {
   if(MessageBox(g_hDlgPropPage,"You need to start FTS in order to interact with it via this MFX plug in.\n\n"
             "Start Fractal Tune Smithy Now?"
             ,"Fractal Tune Smithy Plug In"
             ,MB_YESNO|MB_TOPMOST
             )
      ==IDYES
     )
   {
    time(&ltime_start);
    if(!StartFTS())
     goto to_return;
   }
   else
   {
    time(&ltime_start);
    goto to_return;
   }
  }
  {
   for(i=0;i<20;i++)
   {
    if(!hwndFTS)
    	hwndFTS=FindWindow(szFractalTuneSmithy,NULL);
    if(hwndFTS&&!started_mfx_relay)
    {
     // MessageBox(g_hDlgPropPage,"Found Hidden Main Window","Debug",0);
     SendMessage(hwndFTS,WM_START_MFX_RELAY,0,0);
     started_mfx_relay=1;
     InitVarsOnStartPlay();
    }
    hwndFTSMFX=hwndFTSMFX_is=FindWindow(SZ_FTS_MFX_HANDLER,NULL);
    if(hwndFTSMFX)
     break;
    Sleep(10);
   }
  }
 }
#ifdef DEBUG_MSGS
 if(hwndFTSMFX)
  MessageBox(g_hDlgPropPage,"Found hwndFTSMFX","Debug",0);
#endif
 to_return:;
 if(hwndFTSMFX&&!started_mfx_relay)
 {
  SendMessage(hwndFTSMFX,WM_START_MFX_RELAY,0,0);
  started_mfx_relay=1;
 }
 in_this=0;
 return hwndFTSMFX;
}

int spawnl_1st_arg_in_quotes(int mode,const char *szPFile,const char *szarg)\
{\
	char szPFileInQuotes[MAX_PATH+2];\
		sprintf(szPFileInQuotes,"\"%s\"",szPFile);\
 return _spawnl(mode,szPFile,szPFileInQuotes,szarg,NULL);\
}

#define ShowUrlInBrowser(szUrl) StartAssociationForExtensionWithArg(".html",".htm",szUrl,NULL)

char * StartAssociationForExtensionWithArg(char *szExt,char *szExt2,char *szArg,int *piHandle)
{
 int iHandle=0;
	char szCmdLine[MAX_PATH];
	char *sz=NULL;
	char quotes_found=0;
	int ipos=0,start_ipos=0;
 char szNewArgs[MAX_PATH];
	szCmdLine[0]=szNewArgs[0]='\0';
 GetCommandLineForAssociation(szCmdLine,szExt,szExt2);
	//szCmdLine is now command line format for entry in registry
	//under HKEY_CLASSES_ROOT | <name for type> | Shell | Open | Command
	//It depends on whether path file contains spaces.
 //With spaces:
	//"<path file>" "arg1" "arg2" ...
	//e.g.
	//"C:\Program Files\Accessories\Wordpad.exe" "%1"
	//
	//Without:
	//<path file> %1
	//C:\WINDOWS\NOTEPAD.EXE  "%1"

	//Check for leading quote. If found, remove all leading quotes, copy command line up to next quote
	//If no leading quote is found, then command line ends at first space.
	for(ipos=0;szCmdLine[ipos]!='\0';ipos++)
	{
		if(szCmdLine[ipos]=='\"')
			quotes_found=1;
		else
			if(!isspace(szCmdLine[ipos]))
				break;
	}
	start_ipos=ipos;//typically will be 1 if a quote is found, 0 otherwise
	if(quotes_found)
	{
		//truncate command line at next quote
		for(ipos=start_ipos;szCmdLine[ipos]!='\0';ipos++)
			if(szCmdLine[ipos]=='\"')
   {
  		szCmdLine[ipos]='\0';
    strcpy(szNewArgs,&szCmdLine[ipos+1]);
				break;
   }
	}
	if(!quotes_found)
		//command line ends at first space
		for(ipos=0;szCmdLine[ipos]!='\0';ipos++)
			if(isspace(szCmdLine[ipos]))
			{
    szCmdLine[ipos]='\0';
    strcpy(szNewArgs,&szCmdLine[ipos+1]);
    break;
   }
	if(szCmdLine[0]=='\0')
		sz="Result of Registry search for HTML or HTM file association command line:\n\n"
					"Couldn't find any App. associated with html files";
 RemoveLeadingAndTrailingWhiteSpace(szNewArgs);
 {
  char szNewArgsWas[MAX_PATH];
  char szArgsInQuotes[MAX_PATH];
  char szMsdosPath[MAX_PATH];
  strcpy(szNewArgsWas,szNewArgs);
  if(strlen(szArg)<MAX_PATH-2)
  sprintf(szArgsInQuotes,"\"%s\"",szArg);
  else
   strcpy(szArgsInQuotes,szArg);
  strcpy(szMsdosPath,szArg);
  GetShortPathName(szArg,szMsdosPath,MAX_PATH);
  if(!replace_token(szNewArgs,szNewArgs,szArgsInQuotes,"\"%1\"",MAX_PATH))
  if(!replace_token(szNewArgs,szNewArgs,szArgsInQuotes,"\"%L\"",MAX_PATH))
  if(!replace_token(szNewArgs,szNewArgs,szMsdosPath,"%1",MAX_PATH))
  if(!replace_token(szNewArgs,szNewArgs,szMsdosPath,"%L",MAX_PATH))
   strcpy(szNewArgs,szArgsInQuotes);
 }
	if(-1==(iHandle=spawnl_1st_arg_in_quotes(_P_NOWAIT,&szCmdLine[start_ipos],szNewArgs)))
	{
		switch(errno)
		{
			case E2BIG: sz=&"Argument list exceeds 1024 bytes";break;
			case EINVAL: sz=&"mode argument is invalid";break;
			case ENOENT: sz=&"File or folder not found";break;
			case ENOEXEC: sz=&"Specified file is not executable or has invalid executable-file format";break;
			case ENOMEM: sz=&"Not enough memory is available to execute new process";break;
		}
	}
 if(piHandle)
  *piHandle=iHandle;
	return sz;
}

char *ShowUrlInBrowserWithDefaultErrorMessage(char *szUrl)
{
	char *sz=ShowUrlInBrowser(szUrl);
	if(sz==NULL)
		;
	else
		switch(errno)
		{
		 case ENOENT: 
    {
     char msg[1024];
     char szCmdLine[MAX_PATH];
     sprintf(msg,"Couldn't locate default web browser app:\n\n%s.\n\nYou can get to the page by typing:\n\n%s\n\ninto the address bar of the browser."
            ,GetBrowserCommandLine(szCmdLine)
            ,szUrl
            );
				 MessageBox(g_hDlgPropPage,msg,"Show url in browser",MB_TOPMOST);
				 break;
    }
		 default:
			 {
				 char szmsg[STRMAX+MAX_PATH];
				 sprintf(szmsg,"Unable to spawn process for default web browser app.\n\nDetails:\n%s.\n\nYou can get to the reg. page by typing:\n\n%s\n\ninto the address bar of the browser."
																				 ,sz,szUrl
																				 );
				 MessageBox(g_hDlgPropPage,szmsg,"Show url in browser",MB_TOPMOST);
			 }
 }
	return sz;
}

#define GetCommandLineForAssociation(szCmdLine,szExt,szExt2)\
 GetCommandLineForAssociationExtraParam("Open",szCmdLine,szExt,szExt2)
char *GetCommandLineForAssociationExtraParam(char *szType,char *szCmdLine,char *szExt,char *szExt2)

//szExt should be the extension _including_ the ".". E.g. ".html"
//szExt2 = optional second type of extension, e.g. ".htm"
//checks szExt first.

//First arg should be array of size MAX_PATH:
//szCmdLine[MAX_PATH];

//Fills szCmdLine with the command line if successful
//Otherwise, szCmdLine=="" on return

{
	HKEY hKeyExt=0;
	HKEY hKeyNameForType=0;
	char szNameForType[STRMAX];
	szCmdLine[0]='\0';
	//need to look in HKEY_CLASSES_ROOT under szExt, to find name for type 
	// e.g. under ".html"
	//Typical name might be: "htmlfile"
	if((szExt!=NULL&&RegOpenKeyEx(HKEY_CLASSES_ROOT,szExt,0,KEY_ALL_ACCESS,&hKeyExt)==ERROR_SUCCESS)
			||(szExt2!=NULL&&RegOpenKeyEx(HKEY_CLASSES_ROOT,szExt2,0,KEY_ALL_ACCESS,&hKeyExt)==ERROR_SUCCESS)
			)
	{
		GetRegEntryFor(hKeyExt,NULL,szNameForType,STRMAX);
		RegCloseKey(hKeyExt);
	}
	if(RegOpenKeyEx(HKEY_CLASSES_ROOT,szNameForType,0,KEY_ALL_ACCESS,&hKeyNameForType)==ERROR_SUCCESS)
	{
		//command line is found under HKEY_CLASSES_ROOT | <name for type> | Shell | Open | Command
		HKEY hKeyShell=0;
		if(RegOpenKeyEx(hKeyNameForType,"Shell",0,KEY_ALL_ACCESS,&hKeyShell)==ERROR_SUCCESS)
		{
			HKEY hKeyOpen=0;
			if(RegOpenKeyEx(hKeyShell,szType,0,KEY_ALL_ACCESS,&hKeyOpen)==ERROR_SUCCESS)
			{
				HKEY hKeyCommand=0;
				if(RegOpenKeyEx(hKeyOpen,"Command",0,KEY_ALL_ACCESS,&hKeyCommand)==ERROR_SUCCESS)
				{
					if(GetRegEntryFor(hKeyCommand,NULL,szCmdLine,MAX_PATH))
					RegCloseKey(hKeyCommand);
				}
			}
			RegCloseKey(hKeyShell);
		}
		RegCloseKey(hKeyNameForType);
	}
#ifdef DEBUG_ASSOCIATION
 {
  FILE *fp=fopen("association_log","a");
  if(fp)
  {
   fprintf(fp,"Command line from registry key %s\\Shell\\Open:\r\n%s,\r\n"
         ,szNameForType,szCmdLine);
   fclose(fp);
  }
 }
#endif
 {
  char szCmdLineExpanded[MAX_PATH];
  ExpandEnvironmentStrings(szCmdLine,szCmdLineExpanded,MAX_PATH);
  strcpy(szCmdLine,szCmdLineExpanded);
 }
 RemoveLeadingAndTrailingWhiteSpace(szCmdLine);
 {
  // Convert to the display path file
  // Result will start with display path in quotes if there are any arguments,
  // otherwise, just the string for the command line
  int iquote_starts=find_char(szCmdLine,'\"'),iquote_ends=0;
  char szDisplayPFile[MAX_PATH];
  char szArgs[MAX_PATH];
  szDisplayPFile[0]=szArgs[0]='\0';
  // only look for quotes about path, not about args if present
  // so needs to start at first char of the command line
  if(iquote_starts==0&&szCmdLine[iquote_starts]=='\"')
  {
   iquote_starts++;
   iquote_ends=iquote_starts+find_char(&szCmdLine[iquote_starts],'\"');
  }
  if(iquote_ends>0)
  {
   // pathfile is in quotes.
   // It could still be the MsDos style short name in quotes
   strncpy(szDisplayPFile,&szCmdLine[iquote_starts],MAX_PATH);
   szDisplayPFile[min(MAX_PATH-1,iquote_ends-iquote_starts)]='\0';
   strcpy(szArgs,&szCmdLine[iquote_ends+1]);
  }
  else
  {
   int ipos_space=0;
   int ii=0;
   strcpy(szDisplayPFile,szCmdLine);
   for(ii=1;;ii++)
    if(isspace(szDisplayPFile[ii]))
    {ipos_space=ii;break;}
   if(ipos_space>0)
   {
    szDisplayPFile[ipos_space]=0;
    strcpy(szArgs,&szCmdLine[ipos_space+1]);
   }
  }
  RemoveLeadingAndTrailingWhiteSpace(szArgs);
  RemoveLeadingAndTrailingWhiteSpace(szDisplayPFile);
	 MakeDisplayName(szDisplayPFile);
  strcpy(szCmdLine,szDisplayPFile);
  if(szArgs[0]!='\0')
  if(strlen(szDisplayPFile)+strlen(szArgs)+3<MAX_PATH)
   sprintf(szCmdLine,"\"%s\" %s",szDisplayPFile,szArgs);
 }
 return szCmdLine;
}


char GetRegEntryFor(HKEY hKey,char *szKey,char *szResult,DWORD dwMAX_KEY)
{
	long lr1;
	char *szT=(char *)malloc((int)dwMAX_KEY+1);
	if(szT)
	{
		lr1=RegQueryValueEx(hKey,szKey,NULL,NULL,(BYTE*)szT
																						,&dwMAX_KEY
																						);
		if(lr1==ERROR_SUCCESS||lr1==234)
		{
			szT[dwMAX_KEY-1]='\0';
			strcpy(szResult,szT);
			free(szT);
			return 1;
		}
		free(szT);
	}
	return 0;
}

void RemoveTrailingWhiteSpace(TCHAR *sz)    
{
 int i;
 /**dbg_tws++;**/
 if(!sz)
  return;
 for(i=strlen(sz)-1;i>0;i--)
 {
  char c=sz[i];
  if(isspace(c))
   sz[i]='\0';
  else
   break;
 }
}

void RemoveLeadingWhiteSpace(TCHAR *sz)    
{
 int i;
 if(!sz)
  return;
 for(i=0;;i++)
 {
  char c=sz[i];
  if(!isspace(c))
  {
   if(i>0)
    substrcpy(sz,&sz[i]);
   break;
  }
 }
}

void RemoveLeadingAndTrailingWhiteSpace(TCHAR *sz)    
{
 RemoveLeadingWhiteSpace(sz);    
 RemoveTrailingWhiteSpace(sz);    
}

char	replace_token(char *szresult,char *szsource
                  ,char *sznewtoken,char *szorigtoken,int iMAX
                  )
{
	char return_value=0;
	int i,ipos=0,ilen=strlen(sznewtoken);
 char *sznew=(char *)malloc(iMAX);
 if(sznew)
 {
	 for(i=0;;i++)
	 {
   char c=szsource[i];
   if(szsource[i]==szorigtoken[0])
   if(substrcmpUpper(&szsource[i],szorigtoken)==0)
   {
    if(ipos+ilen<iMAX)
    {
     strcpy(&sznew[ipos],sznewtoken);
     ipos+=ilen;
     i+=strlen(szorigtoken);
     return_value=1;
     continue;
    }
    else
     break;
   }
   sznew[ipos++]=c;
		 if(szsource[i]=='\0'||ipos>=iMAX)
			 break;
  }
  sznew[ipos]='\0';
  strcpy(szresult,sznew);
  FREE_IF_NON_ZERO(sznew)
 }
	return return_value;
}

 char *GetProgramLocationFromCommandLine(char *szEntireCommandLine,char *szLocation,char truncate_to_folder)
 {
  // finds the prog. location e.g.
  // "C:\PROGRA~1\INTERN~1\iexplore.exe" - nohome
  // ->
  // C:\PROGRA~1\INTERN~1\iexplore.exe
  // second arg NULL = replace contents of szEntireCommandLine
 	int i=0;
  char *szLocationLocal=szLocation?szLocation:szEntireCommandLine;
	 {
		 int iquot=0,nquot_found=0;
		 for(i=strlen(szEntireCommandLine);i>=0;i--)
			 if(szEntireCommandLine[i]=='\"')
			 {nquot_found++;if(nquot_found%2==1)iquot=i;}
    if(truncate_to_folder)
    {
			  for(i=nquot_found>0?iquot:strlen(szEntireCommandLine);i>=0;i--)
		   if(szEntireCommandLine[i]=='\\'||szEntireCommandLine[i]==':')
		   {i++;break;}
    }
    else
     if(nquot_found)
      i=iquot;	 }
	 if(szEntireCommandLine[0]=='\"')
	 {
		 i=max(0,i-1);
		 substrncpy(szLocationLocal,&szEntireCommandLine[1],i);
	 }
	 else
		 if(i>0)
			 substrncpy(szLocationLocal,szEntireCommandLine,i);
	 if(i>0&&szLocationLocal[i-1]=='\"')
		 szLocationLocal[i-1]='\0';//shouldn't happen = szEntireCommandLine with no drive or path
	 else
		 szLocationLocal[i]='\0';
  return szLocationLocal;
 }

 
void MakeDisplayName(char *szPFile)
{
 // converts entire path into a display name
 char szToPrefix[MAX_PATH];
 char szSoFar[MAX_PATH];
 char out_of_space=0;
 SHFILEINFO sfi;
 char szPathFile[MAX_PATH];
 char szResult[MAX_PATH];
 char first_time=1;
 char error=0;
 int nloops=0;
 int idotPFile=find_char_from_end(szPFile,'.');
 int ifolderPFile=find_char_from_end(szPFile,'\\');
 char szExt[MAX_PATH];
 szExt[0]='\0';
 if(idotPFile>ifolderPFile)
  strcpy(szExt,&szPFile[idotPFile]);
 strcpy(szPathFile,szPFile);
 szSoFar[0]='\0';
 szToPrefix[0]='\0';
 for(;;)
 {
  int ifolder=find_char_from_end(szPathFile,'\\');
  nloops++;
  if(nloops>1000)
   break;
  if(ifolder>0)
  {
   char szArgs[MAX_PATH];
   int ipos_space=-1;
   szArgs[0]='\0';
		 SHGetFileInfo(szPathFile,0,&sfi,sizeof(sfi),SHGFI_DISPLAYNAME);
   if(sfi.szDisplayName[0]=='\0')
   if(first_time)
   for(;;)
   {
    nloops++;
    if(nloops>1000)
     break;
    if(ipos_space>=0)
     szPathFile[ipos_space]=' ';
    ipos_space=find_char_from_end(szPathFile,' ');
    if(ipos_space>ifolder)
    {
     szPathFile[ipos_space]='\0';
  		 SHGetFileInfo(szPathFile,0,&sfi,sizeof(sfi),SHGFI_DISPLAYNAME);
     if(sfi.szDisplayName[0]!='\0')
     {
      strcpy(szArgs,&szPathFile[ipos_space+1]);
      break;
     }
    }
    else
     break;
   }
   first_time=0;
   if(sfi.szDisplayName[0]=='\0')
   {error=1;break;}
		 strcpy(szToPrefix,sfi.szDisplayName);
   if(szSoFar[0]=='\0')
    strcpy(szSoFar,szToPrefix);
   else
   if(strlen(szToPrefix)+strlen(szSoFar)+strlen(szArgs)+3<MAX_PATH)
   {
    if(szArgs[0]=='\0')
     sprintf(szResult,"%s\\%s",szToPrefix,szSoFar);
    else
     sprintf(szResult,"%s\\%s %s",szToPrefix,szSoFar,szArgs);
    strcpy(szSoFar,szResult);
   }
   else
   {out_of_space=1;break;}
   szPathFile[ifolder]='\0';
  }
  else
   break;
 }
 if(!error)
 if(!out_of_space)
 {
  if(strlen(szPathFile)+strlen(szSoFar)+2<MAX_PATH)
   sprintf(szPFile,"%s\\%s",szPathFile,szSoFar);
  if(szExt[0]!='\0')
  {
   int idot=find_char_from_end(szPFile,'.');
   if(strcmpi(&szPFile[idot],szExt)!=0)
   if(strlen(szPFile)+strlen(szExt)<MAX_PATH)
    sprintf(szPFile,"%s%s",szPFile,szExt);
  }
 }
}


void substrcpy(char *sz1,char *sz2)
{
 //version that is safe for copying a
 // string to a substring of itself
 // as the c documentation says not to
 // use strcpy in this way (though it works)
 int i=0;
 if(!sz1||!sz2)
  return;
 for(;;i++)
 {
  char c=sz1[i]=sz2[i];
  if(c=='\0')
   return;
 }
}

int find_char(char *sz,char c)
{
	int ipos;
	for(ipos=0;sz[ipos];ipos++)
		if(sz[ipos]==c)
			return ipos;
	return 0;
}

char substrcmpUpper(const char * pstr1,const char * pstrsubstr)
//returns 0 if the same, or lpstrsubstr a sub string of lpstr1
{
long i;
char c1[2],c2[2];
char return_value=0;
c1[1]=c2[1]='\0';
if(pstr1==NULL||pstrsubstr==NULL)                          
{return_value=1;goto to_return;}
for(i=0;;i++)
 {
 c1[0]=pstr1[i];
 c2[0]=pstrsubstr[i];
 if(c2[0]=='\0')
{return_value=0;goto to_return;}
 CharUpper(c1);
 CharUpper(c2);
 if(c1[0]!=c2[0])
{return_value=1;goto to_return;}
 }
 to_return:
 return return_value;
}


void substrncpy(char *sz1,char *sz2,int nmax_chars)
{
 //version that is safe for copying a
 // string to a substring of itself
 // as the c documentation says not to
 // use strcpy in this way (though it works)
 int i=0;
 if(!sz1||!sz2)
  return;
 for(;i<nmax_chars;i++)
 {
  char c=sz1[i]=sz2[i];
  if(c=='\0')
   return;
 }
}

int find_char_from_end(char *sz,char c)
{
	int iext_pos;
#ifdef DO_SKIP
	return;
#endif
	for(iext_pos=strlen(sz);iext_pos>0;iext_pos--)
		if(sz[iext_pos]==c)
			return iext_pos;
	return 0;
}


void MakePathFile(char *szPathFile,char *szPath,char *szFile)
{
 UINT uText=0;
 if(!szPath||!szFile)
  return;
 if(szFile[1]==':')
  strcpy(szPathFile,szFile);
	// {if(szPathFile!=szPath)strcpy(szPathFile,szFile);}
 else
 {
  int ipos=0,nfolders_retrace=0;
  char szTPath[MAX_PATH],szTFile[MAX_PATH];
  strncpy(szTPath,szPath,MAX_PATH);
  szTPath[MAX_PATH-1]='\0';
  strncpy(szTFile,szFile,MAX_PATH);
  szTFile[MAX_PATH-1]='\0';
  strcpy(szPathFile,szTPath);
	 uText=(UINT)strlen(szPathFile);
  if(szTPath[0]!='\0'&&szTPath[strlen(szTPath)-1]!='\\')
		 strcatsprintf(&uText,MAX_PATH,szPathFile,"\\");
  for(;;)
  {
   char c=szTFile[ipos];
   if(c=='.')
   {
    if(substrcmp(&szTFile[ipos],".\\")==0)
    {ipos+=2;continue;}
    if(substrcmp(&szTFile[ipos],"..\\")==0)
    {nfolders_retrace++;ipos+=3;continue;}
    break;
   }
   else
    break;
  }
  if(nfolders_retrace>0)
  {
   szPathFile[max(0,strlen(szPathFile)-1)]='\0';//remove the '\\' at the end
   for(;nfolders_retrace>0;nfolders_retrace--)
   {
    int ifolder=find_char_from_end(szPathFile,'\\');
    if(ifolder>0)
     szPathFile[ifolder]='\0';
    else
     break;
   }
   uText=strlen(szPathFile);
		 strcatsprintf(&uText,MAX_PATH,szPathFile,"\\");
  }
	 strcatsprintf(&uText,MAX_PATH,szPathFile,"%s",&szTFile[ipos]);
	 szPathFile[MAX_PATH-1]='\0';
 }
 {
  // remove any duplicated folder signs -
  // can happen from previous buggy
  // versions trying to add folder ending
  // when it already has one. Shouldn't
  // happen any more now.
  int i1=0,i2=0;
  char cprev=0;
  for(i1=0;szPathFile[i1]!='\0';i1++)
  {
   char c=szPathFile[i1];
   if(c=='\\')
   if(cprev=='\\')
    continue;
   cprev=c;
   szPathFile[i2++]=c;
  }
  szPathFile[i2]='\0';
 }
}



int strcatsprintf(UINT *puPos,UINT uMax,PSTR pstr,const TCHAR *format,...)
{
	char *pArguments;
	int nchars_written=0;
	UINT uExtraMem=strlen(format)*2;
 char sztmsg[STRMAX];
	char *szmsg2=sztmsg;
	char szmsg2_alloc=0;
	va_start(pArguments,format);
	if(uExtraMem>=STRMAX)
	{szmsg2=(char *)malloc(uExtraMem+10240);szmsg2_alloc=1;}
	if(szmsg2)
	{
		nchars_written=vsprintf(szmsg2,format,pArguments);
		if(*puPos+nchars_written>=uMax)
			nchars_written=0;
		else
		{
			strcpy(&pstr[*puPos],szmsg2); 
			(*puPos)+=nchars_written;
		}
		if(szmsg2_alloc)
			free(szmsg2);
	}
	va_end(pArguments);
	return nchars_written;
}


char substrcmp(const TCHAR * pstr1,const TCHAR * pstrsubstr)
//returns 0 if the same, or lpstrsubstr a sub string of lpstr1
{
long i;
char c1[2],c2[2];
char return_value=0;
c1[1]=c2[1]='\0';
if(pstr1==NULL||pstrsubstr==NULL)                          
{return_value=1;goto to_return;}
for(i=0;;i++)
 {
 c1[0]=pstr1[i];
 c2[0]=pstrsubstr[i];
 if(c2[0]=='\0')
{return_value=0;goto to_return;}
 if(c1[0]!=c2[0])
{return_value=1;goto to_return;}
 }
 to_return:
 return return_value;
}



void ShowFileForExtension(char *szPFile,char *szFile,char *szCaption,char *sztype,char *szExtType,char *szExt1,char *szExt2)
{
 char ok=0;
 char *sz=NULL;
 char is_html=strcmpi(szExt1,".html")==0||strcmpi(szExt2,".html")==0||strcmpi(szExt1,".htm")==0||strcmpi(szExt2,".htm")==0?1:0;
 char szextra_msg[STRMAX+MAX_PATH];
 char szLocalPFile[MAX_PATH];
 strcpy(szLocalPFile,szPFile);
 szextra_msg[0]='\0';
 if(is_html)
  sprintf(szextra_msg,"\n\nThe url is: %s\n\nYou can type this into the address bar of your web browser"
         ,szLocalPFile
         );
 // if(substrcmpUpper(szLocalPFile,"http://")!=0)
 if(szLocalPFile[1]==':')
 {
  char szLocalPFile2[MAX_PATH];
  char inumber=find_char_from_end(szLocalPFile,'#');
  strcpy(szLocalPFile2,szLocalPFile);
  if(is_html&&inumber>0)
   szLocalPFile2[inumber]='\0';
  if(FileExists(szLocalPFile2))
		 ok=1;
  if(!ok)
  {
		 char szmsg[STRMAX*2+MAX_PATH*3];
   // in case of html files, may have a bookmark at the end to remove.
   // to check if the file exists
   if(is_html&&inumber>0)
		  sprintf(szmsg,"%s %s doesn't exist.\n\n"
									  "Location checked:\n%s\n\n"
           "Complete url with bookmark:\n%s\n\n%s" 
									  ,sztype,szFile,szLocalPFile2,szLocalPFile,szextra_msg
									  );
   else
		  sprintf(szmsg,"%s %s doesn't exist.\n\n"
									  "Location checked:\n%s%s" 
									  ,sztype,szFile,szLocalPFile2,szextra_msg
									  );
	  MessageBox(g_hDlgPropPage,szmsg
															  ,szCaption,MB_TOPMOST
															  );
   return;
  }
 }
 else
  ok=1;
	if(ok)
	{
  int handle=0;
		sz=StartAssociationForExtensionWithArg(szExt1,szExt2,szLocalPFile,&handle);
	}
	if(sz!=NULL||!ok)
	{
		char szmsg[STRMAX*2+MAX_PATH*2];
		sprintf(szmsg,"Couldn't start association for %s %s.\n\n"
									"Location:\n%s%s" 
									,sztype,szFile,szLocalPFile
         ,szextra_msg
									);
  errno=0;
		if(sz!=NULL)
		switch(errno)
		{
			case ENOENT: 
   {
    char msg[1024];
    char szCmdLine[MAX_PATH];
    sprintf(msg,"Files of type %s - the application associated with this type wasn't found:\n\n%s.\n\n"              
									  "The file to open was %s %s" 
								   "The application associated with the type is:\n%s%s" 
           ,szExtType
           ,GetProgramLocationFromCommandLine(GetCommandLineForAssociation(szCmdLine,szExt1,szExt2),0,0)
							    ,sztype,szFile,szLocalPFile
           ,szextra_msg
           );
			 MessageBox(g_hDlgPropPage,msg
																	 ,szCaption,MB_TOPMOST
																	 );
			 break;
   }
			default:
				{
     char szCmdLine[MAX_PATH];
     if(ok)
					sprintf(szmsg,"Files of type %s - application couldn't be started\n\nDetails:\n%s.\n\n"
												"File to open:\n%s\n\nFolder + file:\n%s\n\n" 
								    "The application associated with the type is:\n%s%s" 
										  ,szExtType,sz
            ,szFile,szLocalPFile
            ,GetProgramLocationFromCommandLine(GetCommandLineForAssociation(szCmdLine,szExt1,szExt2),0,0)
            ,szextra_msg
												);
					MessageBox(g_hDlgPropPage,szmsg,szCaption,MB_TOPMOST);
				}
				break;
		}
	}
}